 function classifyResult = classifyFromHsIntervals(features)
%
% This function gives the classification result for heart sound recording
% using the obtained features
%
%
% INPUTS:
% features: the obtained features
%
% OUTPUTS:
% classifyResult: classification result for the heart sound recording
% classifyResult = 1 for abnormal recording
%                = -1 for normal recording
%                = 0 for unsure recording (too noisy)
%
%
% Written by: Chengyu Liu, January 22 2016
%             chengyu.liu@emory.edu
%
% Last modified by:
%
%
% $$$$$$ IMPORTANT
% Please note: the following classificaiton rule (formula) was based on the feature
% selection results using the logistic regression model from the 20 features on the balanced training database.
% You can construct the more accurate classification rule based on the obtained featuers, or
% based on the features you generated, or other information you think useful

%% You can use the logistic regression model to train the classification model to obtian the predictor for normal/abnormal classification
% Reference codes for using logistic regression model are given as follows:

% [B,dev,stats] = glmfit(features, Reference_labels, 'binomial','link','logit');  
% % features: the obtained features; 
% % Reference_labels: reference classification results, for glmfit.m,Reference_labels should be binary inputs (1 for abnormal and 0 for normal)
% predictor     = glmval(B,features,'logit',stats);
% % the typical thr=0.5 is used for calssifying abnormal (predictor>=thr) and normal (predictor<thr)

%% We give the B metrix by training logistic regression model on the validation set to facilitate your use 
% % You are strongly suggested to re-train the logistic regression model on all training set to update the B metrix to obtain more accurate classification results. 

% xa = load('trainedClassifier2016.mat');
%xa = load('trainnewclassifier.mat');
xa = load('trainnewclassifier.mat');
%  datasetTable=xa.xa;
 trainClassifier=xa.trainedClassifierftr;
test=features;
% [test_norm] = featureNormalize(test);
test = table(test);
test.Properties.VariableNames = {'column'};
test.column_1 = test.column(:,1);
test.column_2 = test.column(:,2);
test.column_3 = test.column(:,3);
test.column_4 = test.column(:,4);
test.column_5 = test.column(:,5);
test.column_6 = test.column(:,6);
test.column_7 = test.column(:,7);
test.column_8 = test.column(:,8);
test.column_9 = test.column(:,9);
test.column_10 = test.column(:,10);
test.column_11 = test.column(:,11);
test.column_12 = test.column(:,12);
test.column_13 = test.column(:,13);
test.column_14 = test.column(:,14);
test.column_15 = test.column(:,15);
test.column_16 = test.column(:,16);
test.column_17 = test.column(:,17);
test.column_18 = test.column(:,18);
test.column_19 = test.column(:,19);
test.column_20 = test.column(:,20);
test.column_21 = test.column(:,21);
test.column_22 = test.column(:,22);
test.column_23 = test.column(:,23);
test.column_24 = test.column(:,24);
test.column_25 = test.column(:,25);
test.column_26 = test.column(:,26);
test.column_27 = test.column(:,27);
test.column_28 = test.column(:,28);
test.column_29 = test.column(:,29);
test.column_30 = test.column(:,30);
test.column_31 = test.column(:,31);
test.column_32 = test.column(:,32);
test.column_33 = test.column(:,33);
test.column_34 = test.column(:,34);
test.column_35 = test.column(:,35);
test.column_36 = test.column(:,36);
test.column_37 = test.column(:,37);
test.column_38 = test.column(:,38);
test.column_39 = test.column(:,39);
test.column_40 = test.column(:,40);
test.column_41 = test.column(:,41);
test.column_42 = test.column(:,42);
test.column_43 = test.column(:,43);
test.column = [];
testcolumn = {'column_1', 'column_2', 'column_3', 'column_4', 'column_5', 'column_6', 'column_7', 'column_8', 'column_9', 'column_10', 'column_11', 'column_12', 'column_13', 'column_14', 'column_15', 'column_16', 'column_17', 'column_18', 'column_19', 'column_20', 'column_21', 'column_22', 'column_23', 'column_24', 'column_25', 'column_26', 'column_27', 'column_28', 'column_29', 'column_30', 'column_31', 'column_32', 'column_33', 'column_34', 'column_35', 'column_36', 'column_37', 'column_38', 'column_39', 'column_40', 'column_41', 'column_42', 'column_43'};
tstdata= test(:,testcolumn);
tstdata= table2array(varfun(@double, tstdata));
% tstdata = tstdata(:,[false true false true true false true true true true true true true true true true true true true false true true true false true true false true true true true true true true false true true true true true true true true]);
 tstdata = tstdata(:,[false true false true false true false true true false true true true true true true true true true false true true true true true true true true false true true true true true true true false true true true true true true]);
% tstdata = tstdata(:,[false false true true true true true true true true false false true true true true true true false true false false true true true true false true true true true true true true false true true true true true true true true]);

% Train a classifier
% % testdata=[testdata1 testdata2];
classifyResult = predict(trainClassifier,tstdata);

end

